'use strict';

var index = require('./main-render-common_@ailhc-egf-core.js');
var _const = require('./const.js');

new index.App();
const fs = require("fs");
const main = {
    load() {
        console.log(`插件加载<----`);
    },
    unload() {
        console.log(`插件卸载---->`);
    },
    methods: {
        log() {
            console.log('Hello World');
        },
        "open-default"() {
            Editor.Panel.open('sn-icon-name');
        },
        open() {
            Editor.Panel.open('sn-icon-name.panel');
        },
        open2() {
            Editor.Panel.open('sn-icon-name.panel2');
        },
        'say-hello'() {
            Editor.Message.send(_const.pluginName, 'hello');
        },
        clicked(args) {
            console.log("执行操作..>");
            let project_path = Editor.Project.path;
            if (!fs.existsSync(project_path + "/native/engine/android")) {
                console.log("未构建安卓项目，请先构建一个安卓项目");
                return;
            }
            let app_name_en = args[0][0];
            let app_name_zh = args[0][1];
            let app_name_translatable = args[1];
            let name_path = project_path + "/native/engine/android/res/values/strings.xml";
            let data = "<resources>\n    <string name={a} translatable={b}>{c}</string> \n</resources>";
            data = data.replace(/{a}/, '"' + app_name_en + '"');
            data = data.replace(/{b}/, '"' + app_name_translatable + '"');
            data = data.replace(/{c}/, app_name_zh);
            fs.unlinkSync(name_path);
            fs.writeFileSync(name_path, data, 'utf8');
            console.log("游戏名称更改完成~");
        },
        clicked1(args) {
            console.log("执行操作..>");
            let project_path = Editor.Project.path;
            if (!fs.existsSync(project_path + "/native/engine/android")) {
                console.log("未构建安卓项目，请先构建一个安卓项目");
                return;
            }
            let bufferList = args[0];
            let names = [];
            for (let name in bufferList) {
                if (bufferList[name] == undefined) {
                    names.push(name);
                }
            }
            if (names.length > 0) {
                console.log("---游戏图标为空---");
                for (let i = 0; i < names.length; i++) {
                    let name = names[i];
                    console.log("游戏图标 " + name + "x" + name + " 为空");
                }
                return;
            }
            let icon_path = {
                "48": project_path + "/native/engine/android/res/mipmap-mdpi/ic_launcher.png",
                "72": project_path + "/native/engine/android/res/mipmap-hdpi/ic_launcher.png",
                "96": project_path + "/native/engine/android/res/mipmap-xhdpi/ic_launcher.png",
                "144": project_path + "/native/engine/android/res/mipmap-xxhdpi/ic_launcher.png",
                "192": project_path + "/native/engine/android/res/mipmap-xxxhdpi/ic_launcher.png"
            };
            for (let name in bufferList) {
                let buffer = Buffer.from(bufferList[name], 'base64');
                createImage(icon_path[name], buffer);
            }
            function createImage(path, dataBuffer) {
                fs.unlinkSync(path);
                fs.writeFileSync(path, dataBuffer);
            }
            console.log("游戏图标更换完成~");
        }
    }
};
new index.MainRenderCommon().doSommonCommon();
module.exports = main;

    
