'use strict';

var index = require('./main-render-common_@ailhc-egf-core.js');
var panelCommon = require('./panel-common.js');
var _const = require('./const.js');

var panelcss = ":host {\r\n    margin: 5px;\r\n}\r\n\r\nh2 {\r\n    color: rgb(219, 205, 182);\r\n}\r\n\r\n.ui_button {\r\n    padding:10px;\r\n    background: #82db5f;\r\n    color: rgb(255, 255, 255);\r\n}\r\n.ui_button:hover {\r\n    opacity: 0.9;\r\n}\r\n\r\n.ui_button_start {\r\n    padding:10px;\r\n    background: #3cb6db;\r\n    color: rgb(255, 255, 255);\r\n}";

var panelHtml = "<h2>星宇晚夜 游戏名称更改</h2>\r\n<hr />\r\n<form>\r\n    游戏名称(en)\r\n    <ui-input id=\"input_en\" value=\"app_name\" disabled></ui-input>\r\n    <hr />\r\n    游戏名称(zh)\r\n    <ui-input id=\"input_zh\"> </ui-input>\r\n    <hr />\r\n\r\n    <ui-checkbox id=\"checkbox_translatable\" value=\"false\" disabled>可译的(translatable)</ui-checkbox>\r\n    <hr />\r\n\r\n    <br>\r\n    <ui-button class=\"ui_button_start\" id=\"btn\">更改</ui-button>\r\n\r\n</form>\r\n<hr />\r\n";

new index.App();
require("fs");
(new panelCommon.PanelCommon()).sayCommon("启动插件 游戏名称更改: " + new Date().toLocaleString());
new index.MainRenderCommon().doSommonCommon();
const panel = {
    linsteners: {
        show() {
        },
        hide() { },
    },
    template: panelHtml,
    style: panelcss,
    $: {
        elem: "div",
        btn: '#btn',
        input_en: "#input_en",
        input_zh: "#input_zh",
        checkbox_translatable: "#checkbox_translatable",
    },
    methods: {
        hello() {
        }
    },
    ready() {
        this.$.btn.addEventListener('confirm', () => {
            let app_name_en = this.$.input_en.value;
            let app_name_zh = this.$.input_zh.value;
            let app_name_translatable = this.$.checkbox_translatable.value;
            let count = 0;
            if (app_name_en.length == 0) {
                console.log("---请填写游戏名称(en)---");
                count++;
            }
            if (app_name_zh.length == 0) {
                console.log("---请填写游戏名称(zh)---");
                count++;
            }
            console.log("-------");
            if (count == 0) {
                Editor.Message.send(_const.pluginName, 'clicked', [[app_name_en, app_name_zh], app_name_translatable]);
            }
        });
    },
    beforeClose() {
        return undefined;
    },
    close() {
        console.log("关闭插件 游戏名称更改: " + new Date().toLocaleString());
    }
};
module.exports = panel;

    
