'use strict';

var _const = require('./const.js');
var panelCommon = require('./panel-common.js');

var panelcss = ":host {\r\n    margin: 5px;\r\n}\r\n\r\nh2 {\r\n    color: rgb(219, 205, 182);\r\n}\r\n\r\n.ui_button_start {\r\n    padding:10px;\r\n    background: #3cb6db;\r\n    color: rgb(255, 255, 255);\r\n}\r\n";

var panelhtml = "<h2>星宇晚夜 游戏图标更换</h2>\r\n<hr />\r\n<ui-button class=\"ui_button_start\" id=\"btn\">更换</ui-button>\r\n<hr />\r\n\r\n<div class=\"panel-body\" style=\"height: 400px; overflow-y:scroll\">\r\n    <div style=\"border: 5px  #887fff; width: 100%; margin: 0 auto;\">\r\n        <span>\r\n\r\n            <span> 48 x 48 </span>\r\n            <input id=\"icon_48\" type=\"file\">\r\n            <div id=\"img_48\"></div>\r\n\r\n            <hr />\r\n\r\n            <span> 72 x 72 </span>\r\n            <input id=\"icon_72\" type=\"file\">\r\n            <div id=\"img_72\"></div>\r\n\r\n            <hr />\r\n\r\n            <span> 96 x 96 </span>\r\n            <input id=\"icon_96\" type=\"file\">\r\n            <div id=\"img_96\"></div>\r\n\r\n            <hr />\r\n\r\n            <span> 144 x 144 </span>\r\n            <input id=\"icon_144\" type=\"file\">\r\n            <div id=\"img_144\"></div>\r\n\r\n            <hr />\r\n\r\n            <span> 192 x 192 </span>\r\n            <input id=\"icon_192\" type=\"file\">\r\n            <div id=\"img_192\"></div>\r\n\r\n            <hr />\r\n        </span>\r\n    </div>\r\n</div>";

(new panelCommon.PanelCommon()).sayCommon("启动插件 游戏图标更换: " + new Date().toLocaleString());
const panel2 = {
    linsteners: {
        show() {
        },
        hide() { },
    },
    style: panelcss,
    template: panelhtml,
    $: {
        elem: "div",
        btn: '#btn',
        icon_48: "#icon_48",
        icon_72: "#icon_72",
        icon_96: "#icon_96",
        icon_144: "#icon_144",
        icon_192: "#icon_192",
        img_48: "#img_48",
        img_72: "#img_72",
        img_96: "#img_96",
        img_144: "#img_144",
        img_192: "#img_192",
    },
    ready() {
        let bufferList = {
            "48": undefined,
            "72": undefined,
            "96": undefined,
            "144": undefined,
            "192": undefined,
        };
        let img_48 = this.$.img_48;
        let img_72 = this.$.img_72;
        let img_96 = this.$.img_96;
        let img_144 = this.$.img_144;
        let img_192 = this.$.img_192;
        this.$.icon_48.onchange = function (e) {
            let file = e.target['files'];
            for (let i = 0; i < file.length; i++) {
                let reader = new FileReader();
                let file1 = file[i];
                reader.readAsDataURL(file1);
                reader.onload = function (result) {
                    let baseData = reader.result;
                    img_48.innerHTML = '<img src="' + baseData + '" alt=""/>';
                    var base64Data = baseData.replace(/^data:image\/\w+;base64,/, "");
                    bufferList["48"] = base64Data;
                };
            }
        };
        this.$.icon_72.onchange = function (e) {
            let file = e.target['files'];
            for (let i = 0; i < file.length; i++) {
                let reader = new FileReader();
                let file1 = file[i];
                reader.readAsDataURL(file1);
                reader.onload = function (result) {
                    let baseData = reader.result;
                    img_72.innerHTML = '<img src="' + baseData + '" alt=""/>';
                    var base64Data = baseData.replace(/^data:image\/\w+;base64,/, "");
                    bufferList["72"] = base64Data;
                };
            }
        };
        this.$.icon_96.onchange = function (e) {
            let file = e.target['files'];
            for (let i = 0; i < file.length; i++) {
                let reader = new FileReader();
                let file1 = file[i];
                reader.readAsDataURL(file1);
                reader.onload = function (result) {
                    let baseData = reader.result;
                    img_96.innerHTML = '<img src="' + baseData + '" alt=""/>';
                    var base64Data = baseData.replace(/^data:image\/\w+;base64,/, "");
                    bufferList["96"] = base64Data;
                };
            }
        };
        this.$.icon_144.onchange = function (e) {
            let file = e.target['files'];
            for (let i = 0; i < file.length; i++) {
                let reader = new FileReader();
                let file1 = file[i];
                reader.readAsDataURL(file1);
                reader.onload = function (result) {
                    let baseData = reader.result;
                    img_144.innerHTML = '<img src="' + baseData + '" alt=""/>';
                    var base64Data = baseData.replace(/^data:image\/\w+;base64,/, "");
                    bufferList["144"] = base64Data;
                };
            }
        };
        this.$.icon_192.onchange = function (e) {
            let file = e.target['files'];
            for (let i = 0; i < file.length; i++) {
                let reader = new FileReader();
                let file1 = file[i];
                reader.readAsDataURL(file1);
                reader.onload = function (result) {
                    let baseData = reader.result;
                    img_192.innerHTML = '<img src="' + baseData + '" alt=""/>';
                    var base64Data = baseData.replace(/^data:image\/\w+;base64,/, "");
                    bufferList["192"] = base64Data;
                };
            }
        };
        this.$.btn.addEventListener('confirm', () => {
            Editor.Message.send(_const.pluginName, "clicked1", [bufferList]);
        });
    },
    beforeClose() {
        return undefined;
    },
    close() {
        console.log("关闭插件 游戏图标更换: " + new Date().toLocaleString());
    },
    methods: {
        helloPanel2(event) {
        }
    }
};
module.exports = panel2;

    
