System.register(["__unresolved_0", "cc", "__unresolved_1"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, NetManager, network, _crd, ws, route, heartbeatTimer, heartbeatResTimeoutTimer, handlers, bindedObj, msgCache, openOrClose, tmpBuf, md5;

  function encode(cmdIndex, data) {
    var dataBuf = strencode(JSON.stringify(data));
    var msg_len = dataBuf.length + 3;
    var buffer = new Uint8Array(msg_len + 4);
    var index = 0;
    buffer[index++] = msg_len >> 24 & 0xff;
    buffer[index++] = msg_len >> 16 & 0xff;
    buffer[index++] = msg_len >> 8 & 0xff;
    buffer[index++] = msg_len & 0xff;
    buffer[index++] = 1 & 0xff;
    buffer[index++] = cmdIndex >> 8 & 0xff;
    buffer[index++] = cmdIndex & 0xff;
    copyArray(buffer, index, dataBuf, 0, dataBuf.length);
    return buffer;
  }

  function handleMsg(data) {
    try {
      var index = 0;

      while (index < data.length) {
        var msgLen = data[index] << 24 | data[index + 1] << 16 | data[index + 2] << 8 | data[index + 3];

        if (data[index + 4] === 1) {
          msgCache.push({
            "id": route[data[index + 5] << 8 | data[index + 6]],
            "data": JSON.parse(strdecode(data.subarray(index + 7, index + 4 + msgLen)))
          });
        } else if (data[index + 4] === 2) {
          //握手
          handshakeOver(JSON.parse(strdecode(data.subarray(index + 5, index + 4 + msgLen))));
        } else if (data[index + 4] === 3) {
          // 心跳回调
          clearTimeout(heartbeatResTimeoutTimer);
          heartbeatResTimeoutTimer = null;
        }

        index += msgLen + 4;
      }
    } catch (e) {
      console.log(e);
    }
  }

  function handshakeOver(msg) {
    md5 = msg.md5;

    if (msg.route) {
      route = msg.route;
    }

    if (msg.heartbeat > 0) {
      heartbeatTimer = setInterval(sendHeartbeat, msg.heartbeat * 1000);
    }

    msgCache.push({
      "id": openOrClose.open,
      "data": null
    });
  }

  function sendHeartbeat() {
    // 心跳
    var buffer = new Uint8Array(5);
    buffer[0] = 1 >> 24 & 0xff;
    buffer[1] = 1 >> 16 & 0xff;
    buffer[2] = 1 >> 8 & 0xff;
    buffer[3] = 1 & 0xff;
    buffer[4] = 3 & 0xff;
    ws.send(buffer.buffer);

    if (heartbeatResTimeoutTimer === null) {
      heartbeatResTimeoutTimer = setTimeout(function () {
        network.disconnect(false);
        msgCache.push({
          "id": openOrClose.close,
          "data": null
        });
      }, 5 * 1000);
    }
  }

  function strencode(str) {
    var byteArray = [];

    for (var i = 0; i < str.length; i++) {
      var charCode = str.charCodeAt(i);

      if (charCode <= 0x7f) {
        byteArray.push(charCode);
      } else if (charCode <= 0x7ff) {
        byteArray.push(0xc0 | charCode >> 6, 0x80 | charCode & 0x3f);
      } else if (charCode <= 0xffff) {
        byteArray.push(0xe0 | charCode >> 12, 0x80 | (charCode & 0xfc0) >> 6, 0x80 | charCode & 0x3f);
      } else {
        byteArray.push(0xf0 | charCode >> 18, 0x80 | (charCode & 0x3f000) >> 12, 0x80 | (charCode & 0xfc0) >> 6, 0x80 | charCode & 0x3f);
      }
    }

    return new Uint8Array(byteArray);
  }

  function strdecode(bytes) {
    var array = [];
    var offset = 0;
    var charCode = 0;
    var end = bytes.length;

    while (offset < end) {
      if (bytes[offset] < 128) {
        charCode = bytes[offset];
        offset += 1;
      } else if (bytes[offset] < 224) {
        charCode = ((bytes[offset] & 0x3f) << 6) + (bytes[offset + 1] & 0x3f);
        offset += 2;
      } else if (bytes[offset] < 240) {
        charCode = ((bytes[offset] & 0x0f) << 12) + ((bytes[offset + 1] & 0x3f) << 6) + (bytes[offset + 2] & 0x3f);
        offset += 3;
      } else {
        charCode = ((bytes[offset] & 0x07) << 18) + ((bytes[offset + 1] & 0x3f) << 12) + ((bytes[offset + 2] & 0x3f) << 6) + (bytes[offset + 3] & 0x3f);
        offset += 4;
      }

      array.push(charCode);
    } // return String.fromCharCode.apply(null, array);


    var res = '';
    var chunk = 8 * 1024;
    var i;

    for (i = 0; i < array.length / chunk; i++) {
      res += String.fromCharCode.apply(null, array.slice(i * chunk, (i + 1) * chunk));
    }

    res += String.fromCharCode.apply(null, array.slice(i * chunk));
    return res;
  }

  function copyArray(dest, doffset, src, soffset, length) {
    for (var index = 0; index < length; index++) {
      dest[doffset++] = src[soffset++];
    }
  }

  function _reportPossibleCrUseOfNetManager(extras) {
    _reporterNs.report("NetManager", "../manager/NetManager", _context.meta, extras);
  }

  _export("network", void 0);

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
    }, function (_unresolved_2) {
      NetManager = _unresolved_2.NetManager;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "9b577wyCwxChrtpxBos/sMK", "network", undefined);

      ws = null;
      route = [];
      heartbeatTimer = null;
      heartbeatResTimeoutTimer = null;
      handlers = {};
      bindedObj = {};
      msgCache = [];
      openOrClose = {
        "open": "state_open",
        "close": "state_close"
      };
      tmpBuf = {
        "len": 0,
        "buffer": new Uint8Array(0)
      };
      md5 = "";

      _export("network", network = class network {
        /**
         * 连接服务器
         * @param host 
         * @param port 
         */
        static connect(host, port) {
          network.disconnect(true);
          tmpBuf.len = 0;
          tmpBuf.buffer = new Uint8Array(0);
          var url = "ws://" + host + ":" + port;
          ws = new WebSocket(url);
          ws.binaryType = 'arraybuffer';

          ws.onopen = function () {
            // 握手
            var md5Msg = strencode(JSON.stringify({
              "md5": md5
            }));
            var msgLen = 1 + md5Msg.length;
            var buffer = new Uint8Array(5 + md5Msg.length);
            buffer[0] = msgLen >> 24 & 0xff;
            buffer[1] = msgLen >> 16 & 0xff;
            buffer[2] = msgLen >> 8 & 0xff;
            buffer[3] = msgLen & 0xff;
            buffer[4] = 2 & 0xff;

            for (var i = 0; i < md5Msg.length; i++) {
              buffer[i + 5] = md5Msg[i];
            }

            ws.send(buffer.buffer);
          };

          ws.onerror = function () {};

          ws.onclose = function () {
            network.disconnect(false);
            msgCache.push({
              "id": openOrClose.close,
              "data": null
            });
          };

          ws.onmessage = function (event) {
            handleMsg(new Uint8Array(event.data));
          };
        }
        /**
         * 断开连接
         * @param clearMsg 是否清空消息队列，请开发者保持为 true
         */


        static disconnect(clearMsg) {
          if (clearMsg === void 0) {
            clearMsg = true;
          }

          if (ws) {
            ws.onopen = function () {};

            ws.onerror = function () {};

            ws.onclose = function () {};

            ws.onmessage = function () {};

            ws.close();
            ws = null;
            tmpBuf.len = 0;
            tmpBuf.buffer = new Uint8Array(0);
            clearInterval(heartbeatTimer);
            clearTimeout(heartbeatResTimeoutTimer);
            heartbeatResTimeoutTimer = null;
          }

          if (clearMsg) {
            msgCache.length = 0;
          }
        }
        /**
         * 添加网络连接成功的消息监听
         * @param cb 
         * @param self 
         */


        static onOpen(cb, self) {
          handlers[openOrClose.open] = cb.bind(self);
          bindedObj[openOrClose.open] = self;
        }
        /**
         * 移除网络连接成功的消息监听
         */


        static offOpen() {
          delete handlers[openOrClose.open];
          delete bindedObj[openOrClose.open];
        }
        /**
         * 添加网络断开的消息监听
         * @param cb 
         * @param self 
         */


        static onClose(cb, self) {
          handlers[openOrClose.close] = cb.bind(self);
          bindedObj[openOrClose.close] = self;
        }
        /**
         * 移除网络断开的消息监听
         */


        static offClose() {
          delete handlers[openOrClose.close];
          delete bindedObj[openOrClose.close];
        }
        /**
         * 添加消息监听
         * @param cmd 
         * @param cb 
         * @param self 
         */


        static addHandler(cmd, cb, self) {
          handlers[cmd] = cb.bind(self);
          bindedObj[cmd] = self;
        }
        /**
         * 移除绑定的消息监听
         * @param self 
         */


        static removeThisHandlers(self) {
          for (var _cmd in bindedObj) {
            if (bindedObj[_cmd] === self) {
              delete bindedObj[_cmd];
              delete handlers[_cmd];
            }
          }
        }
        /**
         * 发送消息
         * @param cmd 
         * @param data 
         */


        static sendMsg(cmd, data) {
          if (!ws || ws.readyState !== 1) {
            console.warn("ws is null");
            (_crd && NetManager === void 0 ? (_reportPossibleCrUseOfNetManager({
              error: Error()
            }), NetManager) : NetManager).instance.connectState = false;
            return;
          }

          var cmdIndex = route.indexOf(cmd);

          if (cmdIndex === -1) {
            console.warn("cmd not exists:", cmd);
            return;
          }

          if (data === undefined) {
            data = null;
          }

          var buffer = encode(cmdIndex, data);
          ws.send(buffer.buffer);
        }
        /**
         * 读取消息
         */


        static readMsg() {
          if (msgCache.length > 0) {
            var tmp = msgCache.shift();

            if (handlers[tmp.id]) {
              handlers[tmp.id](tmp.data);
            }
          }
        }

      });

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=network.js.map