"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mydog_1 = require("mydog");
const lobby_1 = require("./app/lobby");
const cpuUsage_1 = require("./cpuUsage");
let app = (0, mydog_1.createApp)();
app.setConfig("connector", { "connector": mydog_1.connector.Ws, "clientOnCb": clientOnCb, "maxConnectionNum": 188, "clientOffCb": clientOffCb });
app.setConfig("encodeDecode", { "msgDecode": msgDecode, "msgEncode": msgEncode });
app.setConfig("logger", (type, level, msg) => {
    if (level === "warn" || level === "error") {
        console.log(msg);
    }
});
app.setConfig("rpc", { "interval": 33 });
app.setConfig("mydogList", () => {
    return [{ "title": "cpu", "value": (0, cpuUsage_1.getCpuUsage)() }];
});
app.configure("connector", () => {
    let lobby = new lobby_1.Lobby();
    app.set("Lobby", lobby);
});
app.start();
process.on("uncaughtException", function (err) {
    console.log(err);
});
function msgDecode(cmd, msg) {
    let msgStr = msg.toString();
    // console.log("↑ ", app.routeConfig[cmd], msgStr);
    return JSON.parse(msgStr);
}
function msgEncode(cmd, msg) {
    // console.log(msg);
    let datas = [];
    for (let s in msg) {
        datas.push(msg[s]);
    }
    // console.log(datas);
    let msgStr = JSON.stringify(datas);
    // console.log(" ↓", app.routeConfig[cmd], msgStr);
    return Buffer.from(msgStr);
}
function clientOnCb(session) {
    console.log("客户端加入");
}
function clientOffCb(session) {
    console.log("客户端离开");
    // console.log(session.uid);
}
