"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Group = void 0;
const mydog_1 = require("mydog");
/**
 * 队组类
 */
class Group {
    constructor(id) {
        /**
         * 队组最大玩家数量
         */
        this.maxPlayer = 3;
        /**
         * 队组id
         */
        this.id = -1;
        /**
         * 队组是否在匹配中
         */
        this.isMatch = false;
        /**
         * 队组玩家列表
         */
        this.playerList = [];
        this.id = id;
    }
    /**
     * 加入玩家对象
     * @param player 玩家对象
     */
    addPlayer(player) {
        player.groupId = this.id;
        this.playerList.push(player);
    }
    /**
     * 移除玩家对象
     * @param player 玩家对象
     */
    removePlayer(player) {
        let index = this.playerList.indexOf(player);
        if (index != -1) {
            player.groupId = -1;
            this.playerList.splice(index, 1);
            if (this.playerList.length == 0) {
                let lobby = mydog_1.app.get("Lobby");
                delete lobby.groupList[this.id];
            }
        }
    }
    /**
     * 队组是否可以加入
     * @returns boolean
     */
    isJoin() {
        let is = false;
        if (this.playerList.length < this.maxPlayer) {
            is = true;
        }
        if (this.isMatch) {
            is = false;
        }
        return is;
    }
    /**
     * 队组是否可以离开
     * @returns boolean
     */
    isLeave() {
        let is = false;
        if (!this.isMatch) {
            is = true;
        }
        return is;
    }
}
exports.Group = Group;
