"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mydog_1 = require("mydog");
class Handler {
    constructor(app) {
        this.app = app;
        this.lobby = this.app.get("Lobby");
    }
    // ping测试
    ping(data, session, next) {
        let msgList = ["uid"];
        let msg = this.getMsg(data, msgList);
        let player = this.lobby.getPlayer(msg.uid);
        if (player != undefined) {
            player.heartbeat = player.maxHeartbeat;
        }
        next({});
    }
    // 登录
    login(data, session, next) {
        if (session.uid) {
            console.log("uid已绑定...");
            return;
        }
        let msgList = ["name"];
        let msg = this.getMsg(data, msgList);
        let uid = this.lobby.login(msg.name, next);
        session.bind(uid);
    }
    // 队组
    group(data, session, next) {
        let msgList = ["type", "uid", "groupId", "removeId"];
        let msg = this.getMsg(data, msgList);
        this.lobby.group(msg);
    }
    // 匹配
    match(data, session, next) {
        let msgList = ["type", "uid", "groupId"];
        let msg = this.getMsg(data, msgList);
        this.lobby.match(msg);
    }
    // 帧数据
    frame(data) {
        let msgList = ["roomId", "data"];
        let msg = this.getMsg(data, msgList);
        this.lobby.frame(msg);
    }
    // 房间
    room(data, session) {
        let msgList = ["type", "uid", "name", "roomId", "frame"];
        let msg = this.getMsg(data, msgList);
        let type = msg.type;
        let uid = msg.uid;
        let name = msg.name;
        let roomId = msg.roomId;
        let frame = msg.frame;
        // console.log("room房间", type);
        if (type == 0) {
            // 查询客户端是否存在，存在则断开
            let client = mydog_1.app.getSession(uid);
            if (client != undefined) {
                client.close();
            }
            // 重新绑定uid
            session.bind(uid);
            console.log("roomId: " + roomId);
            // 重连大厅
            if (roomId == -1) {
                console.log("重连大厅");
                // 创建玩家
                this.lobby.createPlayer(uid, name, false);
                let player = this.lobby.getPlayer(uid);
                mydog_1.app.sendMsgByUid(5 /* connector_main_room */, { type: 0, data: player }, [uid]);
            }
            else {
                // 重连房间 未完善 2022年4月2日22:36:30 明天继续 拜拜 晚安
                // 完成 2022年4月3日11:35:45
                console.log("重连房间");
                let room = this.lobby.getRoom(roomId);
                if (room != undefined) {
                    room.reconnect(uid, frame);
                }
                else {
                    // 房间不存在
                    // 创建玩家
                    this.lobby.createPlayer(uid, name, false);
                    let player = this.lobby.getPlayer(uid);
                    mydog_1.app.sendMsgByUid(5 /* connector_main_room */, { type: 2, data: player }, [uid]);
                }
            }
        }
        if (type == 1) {
            let room = this.lobby.getRoom(roomId);
            if (room != undefined) {
                room.quitRoom(uid);
            }
        }
    }
    getMsg(data, msgList) {
        let msg = {};
        for (let i = 0; i < msgList.length; i++) {
            msg[msgList[i]] = data[i];
        }
        return msg;
    }
}
exports.default = Handler;
