"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RpcSocketPool = void 0;
class RpcSocketPool {
    constructor() {
        this.rpcSockets = {};
    }
    /**
     * Add socket
     */
    addSocket(id, socket) {
        this.rpcSockets[id] = socket;
    }
    /**
     * Remove socket
     */
    removeSocket(id) {
        delete this.rpcSockets[id];
    }
    /**
     * send messages
     */
    sendMsg(id, msg) {
        let socket = this.rpcSockets[id];
        if (socket) {
            socket.send(msg);
        }
    }
    /**
     * Get socket
     */
    getSocket(id) {
        return this.rpcSockets[id];
    }
}
exports.RpcSocketPool = RpcSocketPool;
